unit BaseObj;
interface
uses
  uRec;

  TYPE
     PBaseObj = ^TBaseObj;
     TBaseObj = object
     private
        Node: POne;
     public
      constructor Init;
      destructor Done; virtual;
      procedure Add(ANewOne: POne); virtual;
      procedure PrintAll; virtual;
      function GetNode: POne;
     end;

implementation

constructor TBaseObj.Init;
begin
  {ࢠ  ᥣ - ଠ  ᨨ}
  Node:=NewOne(cVersion, cVersion, 0);
end;

function TBaseObj.GetNode: POne;
begin
  GetNode:=Node
end;

procedure TBaseObj.Add(ANewOne: POne);
var p: POne;
begin
  if ANewOne = nil then Exit;
  {室 ᫥ }
  p:=Node;
  while  p^.Next <> nil do
       p:=p^.Next;
  p^.Next:=ANewOne;
  p^.Next^.Next := nil
end;

procedure TBaseObj.PrintAll;
var p: POne;
begin
   p:=Node;
   while p <> nil do
   begin
    if Copy(p^.Info.Name,1,3) <> 'Ver' then PrintFullInfo(p);
     p:=p^.Next
   end
end;

destructor TBaseObj.Done;
var p: POne;
begin
  While Node <> nil do
  begin
    p:=Node^.Next;
    Dispose(Node);
    Node:=p
  end
end;

BEGIN
END.
